diff --git a/programs/ssl/ssl_server2.c b/programs/ssl/ssl_server2.c
index 807f880f83e..b335b1c3f5c 100644
--- a/programs/ssl/ssl_server2.c
+++ b/programs/ssl/ssl_server2.c
@@ -3199,7 +3199,7 @@ int main( int argc, char *argv[] )
         {
             mbedtls_printf( " failed\n  ! mbedtls_ssl_tls_prf returned -0x%x\n\n",
                             -ret );
-            goto exit;
+            goto reset;
         }
 
         mbedtls_printf( "    EAP-TLS key material is:" );
@@ -3220,7 +3220,7 @@ int main( int argc, char *argv[] )
          {
              mbedtls_printf( " failed\n  ! mbedtls_ssl_tls_prf returned -0x%x\n\n",
                              -ret );
-             goto exit;
+             goto reset;
          }
 
         mbedtls_printf( "    EAP-TLS IV is:" );
diff --git a/tests/ssl-opt.sh b/tests/ssl-opt.sh
index cef87bceba3..d61c3d9f8d3 100755
--- a/tests/ssl-opt.sh
+++ b/tests/ssl-opt.sh
@@ -7949,7 +7949,11 @@ run_test    "export keys functionality" \
             -s "exported ivlen is "  \
             -c "exported maclen is " \
             -c "exported keylen is " \
-            -c "exported ivlen is "
+            -c "exported ivlen is " \
+            -c "EAP-TLS key material is: "\
+            -s "EAP-TLS key material is: "\
+            -c "EAP-TLS IV is: " \
+            -s "EAP-TLS IV is: "
 
 # Final report
 
